#!/usr/bin/perl -w
# psp.pl <file_name>
# load iTunes' library and play party shuffle
# wrote by cheekcat<cheekcat@cheekcat.ath.cx> http://cheekcat.ath.cx/
# version 1.0

#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

# n ǡζ
# p ǡ

use strict;

use Encode qw/from_to/;
use POSIX ":sys_wait_h";
use Errno qw(EAGAIN);

#---configure Start
my $prefix="file://localhost/C:";
my $mount_on="/mnt/win";
my $encode_to="euc-jp";
my @shuffle_rule=(1,2,3,4,5,6);
#my @shuffle_rule=(0,0,0,0,0,1);
my $mpg123="/usr/bin/mpg123";
#---configure End

# prefix:iTunesΥ饤֥ΥեؤΥեѥǺʬ
#        WindowsǤiTunesǡCɥ饤֤˲ڤ֤Ƥ "file://localhost/C:" ˤʤޤ
# mount_on:prefixʬǺʬɤ֤뤫줾Υɥ饤֤Υޥꤷޤ
# encode_to:ե륷ƥǻȤƤʸɤꤷޤ
# shuffle_rule:ƥ졼Ȥκ٤ꤷޤ줾οʸ줾Υ졼Ȥκ٤ˤʤޤ
#              shuffle_rule="45" ȤiPodΥȥåץ졼ȤΤ褦˺ޤ
# mpg123:ڥե뤿Υޥ(mpg123)ؤΥѥꤷޤ

my @sdata=([],[],[],[],[],[]);
our $zombies=0;

$SIG{CHLD}=sub{$zombies++;};

#check arg
my $file=shift;
die "Usage:pshuffle.pl <iTunes' Library file name>" if($file eq "");

#check if file is exist
die "file not exist" unless(-f $file);
die "permission denied" unless(-r $file);

open IN,"< $file";

#file pattern check
while(<DATA>){
    chomp;
    last if(/^End_Of_Data$/);
    die "File:$file is not valid iTunes' Library" unless(<IN> =~ /^$_[\r\n]*$/);
}
print "File match\n";

my $lastrate;

my $tild="";
from_to($tild,"euc-jp","utf-8");

while(<IN>){
    $lastrate=0 if(/<dict>/);
    $lastrate=$1 if(/<key>Rating<\/key><integer>([0-9]*)<\/integer>/);
    if(/<key>Location<\/key><string>([^<]*)<\/string>/){
	my $temp=$1;
	$temp =~ s/^$prefix/$mount_on/;
	$temp =~ s/\/$//;
	#print $temp,"\n";
	$temp =~ s/%EF%BD%9E/$tild/g;
	$temp =~ s/%([0-9A-Fa-f][0-9A-Fa-f])/pack('H2', $1)/eg;
	#print $temp,"\n";
	$temp =~ s/&\#38;/&/g;
	from_to($temp,"utf-8",$encode_to);
	#print $temp,"\n";
	push(@{$sdata[$lastrate/20]},$temp);
    }
}
close IN;

my $total=0;
for(my $i=0;$i<6;$i++){
    $shuffle_rule[$i]=$shuffle_rule[$i]*@{$sdata[$i]};
    $total+=$shuffle_rule[$i];
}

for(;;){
    my $num=int(rand($total));
    for(my $i=0;$i<6;$i++){
	if($num< $shuffle_rule[$i]){
	    $num=$i;
	    last;
	}else{
	    $num-= $shuffle_rule[$i];
	}
    }
    my $song=$sdata[$num][int(rand(@{$sdata[$num]}))];
    print "Rate $num - $song start playing...\n";

  FORK:{
      if(my $pid = fork){
	  for(;;){
	      last if ($zombies && ! is_stop($pid)) ;
	      my $key=getone();
	      SWITCH : {
		  if($key eq "n") {
		      kill 'INT',$pid;
		  }elsif($key eq "p") {
		      if(is_stop($pid)){
			  kill 'CONT',$pid;
			  $zombies=0;
		      }else{
			  kill 'STOP',$pid;
		      }
		  }
	      }
	  }
	  $zombies=0;
	  waitpid $pid,0;
      }elsif(defined $pid){
	  open STDOUT,">/dev/null";
	  #open STDERR,">&STDOUT";
	  exec $mpg123,"-q",$song;
      }elsif($! == EAGAIN){
	  print STDERR "Can't fork:waiting...\n";
	  sleep 5;
	  redo FORK;
      }else{
	  die "Can't fork:$!\n";
      }
  }
}

BEGIN{
    use POSIX qw(:termios_h);
    my ($term,$oterm,$echo,$noecho,$fd_stdin);
    $fd_stdin=fileno(STDIN);
    $term=POSIX::Termios->new();
    $term->getattr($fd_stdin);
    $oterm = $term->getlflag();
    $echo = ECHO | ECHOK | ICANON;
    $noecho = $oterm & ~$echo;
    sub cbreak{
	$term->setlflag($noecho);
	$term->setcc(VTIME,1);
	$term->setattr($fd_stdin,TCSANOW);
    }
    sub cooked {
	$term->setlflag($oterm);
	$term->setcc(VTIME,0);
	$term->setattr($fd_stdin,TCSANOW);
    }
    sub getone {
	my $key="";
	cbreak();
	sysread(STDIN,$key,1);
	cooked();
	return $key;
    }
}
END{cooked();}

sub is_stop {
    my $pid=shift;
    open IN,"< /proc/$pid/stat";
    my @temp = split " ",<IN>;
    close IN;
    return ($temp[2] eq "T")?1:0;
}

__DATA__
<\?xml version="1.0" encoding\="UTF-8"\?>
<!DOCTYPE plist PUBLIC "-//Apple Computer//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">
<plist version="1.0">
End_Of_Data
